#include <bits/stdc++.h>
#define maxn 200050

using namespace std;

int n,q,l,r;
int a[maxn];
int k[maxn];

int main()
{
    cin >> n;
    for(int i=0; i<n; i++){
        cin >> a[i];
    }
    l=0;
    r=0;
    for(int i=1; i<n; i++){
        if(a[i]>=a[i-1]){
            r++;
        }
        else{
            for(int j=l; j<=r; j++){
                k[j]=i;
            }
            r=i;
            l=i;
        }
    }
    for(int i=l; i<=r; i++){
        k[i]=n;
    }
    cin >> q;
    while(q--){
        cin >> l >> r;
        l--;
        r--;
        int z=k[l];
        int y=a[z-1];
        int x=a[z-2];
        int t=a[z+1];
        if(z>=r){
            cout << "DA\n";
        }
        else{
            if(x<=z || y==l){
                if(k[z]>r){
                    cout << "DA\n";
                }
                else{
                    cout << "NE\n";
                }
            }
            else{
                if(t<y){
                    cout << "NE\n";
                }
                else{
                    if(k[t]>r){
                        cout << "DA\n";
                    }
                    else{
                        cout << "NE\n";
                    }
                }
            }
        }
    }
}